#pragma once

#include "qsbieapi_global.h"

#include "SbieStatus.h"

class QSBIEAPI_EXPORT CSbieUtils
{
public:

	enum EComponent
	{
		eNone = 0,
		eDriver = 0x01,
		eService = 0x02,
		eAll = 0xFF
	};

	static SB_STATUS		DoAssist();

	static SB_STATUS		Start(EComponent Component);
	static SB_STATUS		Stop(EComponent Component);
	static bool				IsRunning(EComponent Component);

	static SB_STATUS		Install(EComponent Component);
	static SB_STATUS		Uninstall(EComponent Component);
	static bool				IsInstalled(EComponent Component);

	static QString			GetContextMenuStartCmd();
	static void				AddContextMenu(const QString& StartPath, const QString& IconPath = QString());
	static void				RemoveContextMenu();

	static bool				CreateShortcut(class CSbieAPI* pApi, QString LinkPath, const QString &LinkName, const QString &boxname, const QString &arguments, const QString &iconPath = QString(), int iconIndex = 0, const QString &workdir = QString(), bool bRunElevated = false);
	static bool				GetStartMenuShortcut(class CSbieAPI* pApi, QString &BoxName, QString &LinkPath, QString &IconPath, quint32& IconIndex, QString &WorkDir);

private:
	static SB_STATUS		ElevateOps(const QStringList& Ops);
	static SB_STATUS		ExecOps(const QStringList& Ops);

	static void				Start(EComponent Component, QStringList& Ops);
	static void				Stop(EComponent Component, QStringList& Ops);

	static void				Install(EComponent Component, QStringList& Ops);
	static void				Uninstall(EComponent Component, QStringList& Ops);

	static void				CreateShellEntry(const wstring& classname, const wstring& cmdtext, const wstring& iconpath, const wstring& startcmd);
};


bool QSBIEAPI_EXPORT ShellOpenRegKey(const QString& KeyName);
